function resetCustomSelect(cssSelector) {
  var $select = jQuery(cssSelector);
  $select.attr('value', '');
  $select.children('span').text('');
}

function dbzTemplateAppend(target, template, name) {
  jQuery('#' + template).clone().attr('id', name).show().appendTo(target);
  var tagName = '#' + name;
  return jQuery(tagName);
};

function setSelectedCustomSelect(cssSelector, value) {
  var $select = jQuery(cssSelector);

  var $option;
  $select.find('li').each(function(i, item) {
    jQuery(item).removeClass('selected');

    if (jQuery(item).attr('value') == value) {
      $option = jQuery(item);
    }
  });

  if ($option) {
    $select.children('span').text($option.text());
    $select.attr('value', $option.attr('value'));

    $option.addClass('selected');
  }
}

function hideCustomSelectOptions(cssSelector) {
  jQuery(cssSelector).children('ul').hide();
}

function onClickCustomSelectOption($option) {
  var $select = $option.parent().parent();
  $select.children('span').text($option.text());
  $select.attr('value', $option.attr('value'));

  $option.parent().hide();
  $option.parent().children('li').removeClass('selected');
  $option.addClass('selected');
}



jQuery('.dbz-wrapper .custom-select').on('click', function(e) {
  e.stopPropagation();

  jQuery(this).children('ul').show();
});

//未选择时点击document隐藏
jQuery(document).click(function() {
  jQuery('.dbz-wrapper .custom-select >ul').hide();
});



(function() {
  window.dbz = window.dbz ? window.dbz : {};
  window.dbz.showResourcePanel = showResourcePanel;
  window.dbz.startUpdate = startUpdate;
  window.dbz.stopUpdate = stopUpdate;

  //滚动
  jQuery("#dbz_main_sc").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark",
    scrollInertia: 400,
    advanced: {
      updateOnContentResize: false
    },
    mouseWheel: {
      disableOver: ["resource-log-thumb-list", "disk_temp_thumb_list"]
    }
  });

  function updateMainScrollbar() {
    jQuery("#dbz_main_sc").mCustomScrollbar("update");
  }

  jQuery("#resource_volume_thumb_list").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
  jQuery("#disk_temp_thumb_list").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
  jQuery("#resource_log_thumb_list").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

  //拖动
  jQuery(".dbz-thumb-list").dragsort({
    dragEnd: function() {},
    dragBetween: false,
    dragSelector: "li",
    dragSelectorExclude: 'select,button'
  });


  var REQUEST_TIMEOUT = 20000;
  var REFRESH_INTERVAL = 3000;
  var REFRESH_INTERVAL_ALLOAD = 15000;
  var REFRESH_INTERVAL_SYSINFO = 60000; //系统信息刷新间隔
  var REFRESH_INTERVAL_SYSLOG = 180000; //系统日志刷新间隔

  var forceStop = false;
  var timerInfoSysinfo = {};
  var timerInfoSyslog = {};
  var timerInfoCpu = {};
  var timerInfoMemory = {};
  var timerInfoNetdevice = {};
  var timerInfoDisk = {};
  var timerInfoDiskSpeed = {};
  var timerInfoVolume = {};
  var netTempData = {};

  var chartCpuUsage;

  var chartMemory;
  var chartSwap;

  var arrNetdevice;
  var lastValueNetdevice = '';
  var chartUploadSpeed;
  var dataUploadSpeed = [];
  var chartDownloadSpeed;
  var dataDownloadSpeed = [];

  var chartWriteSpeed;
  var dataWriteSpeed = [];
  var chartReadSpeed;
  var dataReadSpeed = [];

  var ectWriteSpeed = [];
  var ectReadSpeed = [];
  var ecs = 1;

  var arrVolumeGroup;
  var lastValueVolumeGroup = '';

  function startUpdate() {
    forceStop = false;

    lastValueNetdevice = '';
    dataUploadSpeed = [];
    dataDownloadSpeed = [];

    lastValueVolumeGroup = '';
    usage_moment();
  }

  function stopUpdate() {
    forceStop = true;

    if (timerInfoSysinfo.lastTimer) {
      clearTimeout(timerInfoSysinfo.lastTimer);
    }
    if (timerInfoSyslog.lastTimer) {
      clearTimeout(timerInfoSyslog.lastTimer);
    }

    if (timerInfoMemory.lastTimer) {
      clearTimeout(timerInfoMemory.lastTimer);
    }

    if (timerInfoDisk.lastTimer) {
      clearTimeout(timerInfoDisk.lastTimer);
    }

    if (timerInfoVolume.lastTimer) {
      clearTimeout(timerInfoVolume.lastTimer);
    }
  }

  function initTranslator() {
    var rt = document.getElementById('dbz');
    var pageTranslators = window.top.UNAS.CreateNodesTranslators(rt.parentNode);
    var OnChangeLanguage = function(e) {
      for (var i = 0; i < pageTranslators.length; i++) {
        var node = pageTranslators[i].node;
        var p = pageTranslators[i].translateProperty;
        node[p] = window.top.UNAS._(pageTranslators[i].originalText);
      }

      jQuery('#jv-netdevicehost .resource-thumb-subtitle').each(function(i, ev){
        var t = jQuery(ev).attr('type');
        jQuery(ev).text(UNAS._('##$@resourcepanel@$##' + t + '##$@resourcepanel@$##'));
      })

      //对应于英文界面，应用不同的样式
      UNAS.CurrentLanguage == 'English' ? jQuery('.dbz-wrapper').addClass('en') : jQuery('.dbz-wrapper').removeClass('en');

      jQuery('#rt_base_boottime').text(formatTimeFromSeconds(jQuery('#rt_base_boottime').attr('time')));
      jQuery("#rb_base_status").text(UNAS._('##$@resourcepanel@$##' + jQuery("#rb_base_status").text() + '##$@resourcepanel@$##'));


      if (chartUploadSpeed) {
        chartUploadSpeed.setOption({
          series: [{
            name: UNAS._('##$@resourcepanel@$##Current Speed##$@resourcepanel@$##')
          }]
        });
      }

      if (chartDownloadSpeed) {
        chartDownloadSpeed.setOption({
          series: [{
            name: UNAS._('##$@resourcepanel@$##Current Speed##$@resourcepanel@$##')
          }]
        });
      }

      if (chartWriteSpeed) {
        chartWriteSpeed.setOption({
          series: [{
            name: UNAS._('##$@resourcepanel@$##Current Speed##$@resourcepanel@$##')
          }]
        });
      }

      if (chartReadSpeed) {
        chartReadSpeed.setOption({
          series: [{
            name: UNAS._('##$@resourcepanel@$##Current Speed##$@resourcepanel@$##')
          }]
        });
      }

    };

    OnChangeLanguage();
    //UNAS.LoadTranslation('/apps/resourcepanel/languages/Translation?v=6.0.28&', OnChangeLanguage);
    window.top.UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    window.addEventListener("unload", function(e) {
      window.top.UNAS.Event.removeEvent('ChangeLanguage', OnChangeLanguage);
    }, false);
  }

  function saveLayout() {
    //保存当前面板的布局
    var obj;
    var arrBox = [];
    jQuery('.resource-thumb').each(function(i, item) {
      obj = {};
      obj.group = jQuery(item).data('group');
      obj.id = jQuery(item).attr('id');
      obj.visible = jQuery(item).is(':visible');
      arrBox.push(obj);
    });
    var arrBoxSimple = [];
    jQuery('.resource-thumb-simple').each(function(i, item) {
      obj = {};
      obj.group = jQuery(item).data('group');
      obj.id = jQuery(item).attr('id');
      obj.visible = !jQuery('#' + jQuery(item).data('ref')).is(':visible');
      arrBoxSimple.push(obj);
    });

    var configData = {
      'box': arrBox,
      'boxSimple': arrBoxSimple
    };
    window.localStorage.setItem("resourcepanel_layout_config", JSON.stringify(configData));
  }

  function initLayout() {
    var configData = window.localStorage.getItem("resourcepanel_layout_config");
    if (configData) {
      var configObj = JSON.parse(configData);
      var i, len;
      var arrBox = configObj.box;
      if (typeof(arrBox) == 'string') {
        arrBox = JSON.parse(arrBox);
      }
      jQuery('.resource-thumb').show();

      var $boxContainer = jQuery('#dbz_thumb_list');
      var $box;
      for (i = 0, len = arrBox.length; i < len; ++i) {
        $box = jQuery('#' + arrBox[i].id);
        $boxContainer.append($box);
        if (!arrBox[i].visible) {
          $box.hide();
        }
      }

      var arrBoxSimple = configObj.boxSimple;
      if (typeof(arrBoxSimple) == 'string') {
        arrBoxSimple = JSON.parse(arrBoxSimple);
      }

      jQuery('.resource-thumb-simple').show();

      var $boxSimpleContainer = jQuery('#dbz_thumb_simple_list');
      var $boxSimple;
      for (i = 0, len = arrBoxSimple.length; i < len; ++i) {
        $boxSimple = jQuery('#' + arrBoxSimple[i].id);
        $boxSimpleContainer.append($boxSimple);
        if (!arrBoxSimple[i].visible) {
          $boxSimple.hide();
        }
      }
    } else {
      jQuery('.resource-thumb-simple').hide();
    }
  }

  // 关闭版块
  jQuery('.resource-thumb-btn-close').click(function() {
    var ref = jQuery(this).data('ref');

    jQuery('#' + ref).fadeOut(function() {
      updateMainScrollbar();
    });
    jQuery('#simple_' + ref).show();
  });

  // 开启板块
  jQuery('.icon-add-box').click(function() {
    var ref = jQuery(this).data('ref');
    jQuery('#simple_' + ref).hide();
    var $targetBox = jQuery('#' + ref);
    jQuery('.dbz-thumb-list').append($targetBox);
    $targetBox.fadeIn(function() {
      updateMainScrollbar();
    });
  });

  var isFading = false;
  // 点击编辑
  jQuery('.dbz-btn-edit').click(function() {
    if (isFading) return;
    jQuery('.resource-thumb').addClass('inEditing');
    jQuery(this).hide();
    jQuery('.dbz-btn-confirm').show();
    isFading = true;
    jQuery('.dbz-thumb-simple-list').fadeIn(function() {
      isFading = false;
      updateMainScrollbar();
    });
  });

  // 点击确定
  jQuery('.dbz-btn-confirm').click(function() {
    if (isFading) return;

    saveLayout();

    jQuery('.resource-thumb').removeClass('inEditing');

    jQuery(this).hide();
    jQuery('.dbz-btn-edit').show();
    isFading = true;
    jQuery('.dbz-thumb-simple-list').fadeOut(600, function() {
      isFading = false;

      updateMainScrollbar();
    });
  });

  //关闭整个面板
  jQuery('.dbz-btn-close').click(function(e) {
    stopUpdate();
    e.stopPropagation();
    document.getElementById('resourcepanel').style.zIndex = 'auto';
    //日过正在编辑
    if (jQuery('.dbz-btn-confirm').is(':visible')) {
      jQuery('.dbz-thumb-simple-list').hide();
      jQuery('.resource-thumb').removeClass('inEditing');
      jQuery('.dbz-btn-edit').show();
      jQuery('.dbz-btn-confirm').hide();
    } else {
      saveLayout();
    }
    document.getElementById('resourcepanel').style.display = 'none';
    jQuery('#dbz').hide();
  });

  function showResourcePanel() {
    initLayout();

    jQuery('#dbz_popup_desc').text('');
    jQuery('#dbz_popup').hide();

    jQuery('#dbz').show();

    updateMainScrollbar();
  }


  //入口
  initTranslator();
  initLayout();
  UNAS.LoadJS("/api/js/echarts.min.js?v=6.0.28&", function() {
    initChart();
    startUpdate();
  });

  //=====================================================================


  //获取内存信息
  function getMemoryInfo(memory) {

    if (memory) {
      //console.log('memory.prcent:'+res.results.memory.prcent);
      //更新chart显示
      chartMemory.setOption({
        series: [{
          data: [Math.round(memory.memuserate)],
          color: {
            type: 'linear',
            colorStops: [{
              offset: 0,
              color: setColor(Math.round(memory.memuserate))
            }]
          }
        }]
      });
      chartSwap.setOption({
        series: [{
          data: [Math.round(memory.swapuserate)],
          color: {
            type: 'linear',
            colorStops: [{
              offset: 0,
              color: setColor(Math.round(memory.swapuserate))
            }]
          }
        }]
      });
    }
  }

  function setColor(v) {
    var color = '#2DBF00';
    if (v <= 50) {
      color = '#2DBF00';
    } else if (v > 50 && v <= 89) {
      color = '#FBC02D';
    } else {
      color = '#F75C4B';
    }
    return color;
  }
  //获取CPU信息
  function getCpuInfo(cpu) {
    var numUsage = Number(cpu.ratio).toFixed(0);
    jQuery('#cpu_usage_num').text(numUsage + '%');
    //更新chart显示
    if (chartCpuUsage) {
      chartCpuUsage.setOption({
        series: [{
          data: [numUsage],
          color: {
            type: 'linear',
            colorStops: [{
              offset: 0,
              color: setColor(numUsage)
            }]
          }
        }]
      });
    }

    var fahrenheit = Math.round(cpu.fahrenheit);
    var numTemp = Math.round(cpu.temperature);
    if (numTemp > 100) {
      numTemp = 100;
    }
    jQuery('#jv-temperature').text(numTemp + '℃');
    jQuery('#jv-fahrenheit').text(fahrenheit + '℉');
    jQuery('#jv-ptb-v').css({
      width: numTemp + '%',
      background: setColor(numTemp)
    })
  }
  var netnic = {
    read_speed : [],
    write_speed : []
  }
  //获取网卡信息
  function getNetdeviceInfo(network) {
    var arr = [];
    for (var v in network.nic) {
      if (network.nic.hasOwnProperty(v)) {
        arr.push(network.nic[v])
        // netTempData[v] = {}
      }
    }
    arrNetdevice = arr;


    jQuery('#jv-netdevicehost').empty();
    var read_speedarr = [];
    var write_speedarr = [];
    for (var i = 0; i < arrNetdevice.length; ++i) {
      var nic = arrNetdevice[i].nic;
      var read_speed = arrNetdevice[i].read_speed;
      var write_speed = arrNetdevice[i].write_speed;

      var netdom = dbzTemplateAppend('#jv-netdevicehost','jvt-netdevice-speed', 'jvt-netdevice-speed-'+ i);
      netdom.find('.netname').text(arrNetdevice[i].nic);
      netdom.find('.netdevice_upload_speed').text(bytesToSize(arrNetdevice[i].read_speed));
      netdom.find('.netdevice_download_speed').text(bytesToSize(arrNetdevice[i].write_speed));
      netdom.find('.chart-container_upload').attr('id', 'netdevice_upload_' + i);
      netdom.find('.chart-container_speed').attr('id', 'netdevice_download_' + i);

      // initnetdevicedata(i, dataUploadSpeed, 'netdevice_upload_' + i);
      // for (var v in netTempData) {
      //   if (v == nic) {
      //     read_speedarr.unshift(read_speed);
      //     write_speedarr.unshift(write_speed);
      //     netTempData[nic] = netnic;
      //     break;
      //   }
      // }
      // netTempData[nic] = {};
      if (netTempData[nic]) {

      }else {
        netTempData[nic] = {};
      }

      if (netTempData[nic]['read_speed']) {
        netTempData[nic]['read_speed'].unshift(read_speed);
      } else {
        netTempData[nic]['read_speed'] = [read_speed];
      }
      if (netTempData[nic]['write_speed']) {
        netTempData[nic]['write_speed'].unshift(write_speed);
      } else {
        netTempData[nic]['write_speed'] = [write_speed];
      }

    }
    // console.log(netTempData);
    for (i = 0, len = arrNetdevice.length; i < len; ++i) {

      ectWriteSpeed.push(initnetdevicedata(i, netTempData[arrNetdevice[i].nic]['read_speed'], jQuery('#jv-netdevicehost .chart-container_upload').eq(i)[0]));
      ectReadSpeed.push(initnetdevicedata(i, netTempData[arrNetdevice[i].nic]['write_speed'], jQuery('#jv-netdevicehost .chart-container_speed').eq(i)[0]));
    }

  }
  //更新显示当前网卡速度
  function updateNetdeviceSpeed(network) {

    //上传
    var arr = [];
    for (var v in network.nic) {
      if (network.nic.hasOwnProperty(v)) {
        arr.push(network.nic[v])
      }
    }
    arrNetdevice = arr;
    if (!arrNetdevice.length) {
      return;
    }
    var read_speedarr = [];
    var write_speedarr = [];
    for (var i = 0; i < arrNetdevice.length; ++i) {
      var nic = arrNetdevice[i].nic;
      var read_speed = arrNetdevice[i].read_speed;
      var write_speed = arrNetdevice[i].write_speed;

      if (netTempData[nic]) {

      }else {
        netTempData[nic] = {};
      }

      if (netTempData[nic]['read_speed']) {
        netTempData[nic]['read_speed'].unshift(read_speed);
      } else {
        netTempData[nic]['read_speed'] = [read_speed];
      }
      if (netTempData[nic]['write_speed']) {
        netTempData[nic]['write_speed'].unshift(write_speed);
      } else {
        netTempData[nic]['write_speed'] = [write_speed];
      }

    }

    for (var i = 0; i < ectWriteSpeed.length; i++) {
      if (ectWriteSpeed[i]) {
        ectWriteSpeed[i].setOption({
          series: [{
            data: netTempData[arrNetdevice[i].nic]['read_speed']
          }]
        });
      }
      jQuery('.netdevice_upload_speed').eq(i).text(bytesToSize(arrNetdevice[i].read_speed));
    }

    for (var i = 0; i < ectReadSpeed.length; i++) {
      if (ectReadSpeed[i]) {
        ectReadSpeed[i].setOption({
          series: [{
            data: netTempData[arrNetdevice[i].nic]['write_speed']
          }]
        });
      }
      jQuery('.netdevice_download_speed').eq(i).text(bytesToSize(arrNetdevice[i].write_speed));
    }

  }
  //strSpeed: ???KB/s; ???MB/s
  function getSpeedAsKb(strSpeed) {
    var reg = new RegExp("(kb/s|mb/s)");
    strSpeed = strSpeed.toLowerCase();
    if (strSpeed.indexOf('mb/s') != -1) {
      return Number(strSpeed.replace(reg, '')) * 1024;
    } else {
      return Number(strSpeed.replace(reg, ''));
    }
  }

  function bytesToSize(bytes) {
    if (bytes === 0) return '0 B/s';
    var k = 1000, // or 1024
      sizes = ['B/s', 'KB/s', 'MB/s', 'GB/s', 'TB/s', 'PB/s', 'EB/s', 'ZB/s', 'YB/s'],
      i = Math.floor(Math.log(bytes) / Math.log(k));

    return (bytes / Math.pow(k, i)).toPrecision(3) + ' ' + sizes[i];
  }

  //获取硬盘信息
  function getDiskInfo(res) {

    var disks = [];
    for (var v in res.results.disk.temperature.devs) {
      if (res.results.disk.temperature.devs.hasOwnProperty(v)) {
        disks.push({
          dev: v,
          celsius: res.results.disk.temperature.devs[v],
          fahrenheit: res.results.disk.fahrenheit.devs[v]
        });
      }
    }
    arrDisk = disks;
    var i, len;
    //填充硬盘列表
    jQuery("#disk_temp_thumb_container").empty();
    var diskName, diskTemp, fahrenheit;
    for (i = 0, len = arrDisk.length; i < len; ++i) {
      diskName = arrDisk[i].dev;
      diskTemp = arrDisk[i].celsius > 100 ? 100 : arrDisk[i].celsius;
      fahrenheit = arrDisk[i].fahrenheit;
      var diskdom = dbzTemplateAppend('#disk_temp_thumb_container', 'jvt-tempitem', 'jvt-tempitem' + i);
      diskdom.find('.tempname').text(diskName);
      diskdom.find('.ptb-v').css({
        Width: diskTemp + '%',
        background: setColor(diskTemp)
      });
      diskdom.find('.temperature').text(diskTemp + '℃');
      diskdom.find('.fahrenheit').text(fahrenheit + '℉');

    }

  }

  //获取硬盘速度
  function getDiskSpeed(diskspeed) {
    diskspeed.speed = diskspeed.speed || {};
    jQuery('#disk_speed_write').text(bytesToSize(diskspeed.speed.write_speed));

    //更新chart显示
    dataWriteSpeed.unshift(diskspeed.speed.write_speed);
    if (chartWriteSpeed) {
      chartWriteSpeed.setOption({
        series: [{
          data: dataWriteSpeed
        }]
      });
    }

    jQuery('#disk_speed_read').text(bytesToSize(diskspeed.speed.read_speed));

    //更新chart显示
    // dataReadSpeed = [3, 10, 20, 5,90]
    dataReadSpeed.unshift(diskspeed.speed.read_speed);
    if (chartReadSpeed) {
      chartReadSpeed.setOption({
        series: [{
          data: dataReadSpeed
        }]
      });
    }
  }

  //获取卷组信息
  function getVolumeInfo(res) {
    var vgs = [];
    for (var v in res.results.storage.vgs) {
      if (res.results.storage.vgs.hasOwnProperty(v)) {
        vgs.push(res.results.storage.vgs[v]);
      }
    }
    arrVolumeGroup = vgs;
    jQuery('#rt_custom_select_volumegroup').empty();
    for (var i = 0; i < vgs.length; i++) {
      var voldom = dbzTemplateAppend("#rt_custom_select_volumegroup", "jvt-volumegroup", "jvt-volumegroup-" + i);
      voldom.find('.volname').text(vgs[i].vg);
      voldom.find('.decimal-text').text(formSizeByte(Number(vgs[i].size)) + ' / ' + formSizeByte(Number(vgs[i].free)));
    }

    if (arrVolumeGroup.length > 0) {
      if (!lastValueVolumeGroup) {
        lastValueVolumeGroup = arrVolumeGroup[0].vg;
      }

      //存储空间模块
      var barWidth = jQuery('#rt_storage_bar_outer').width();
      var totalBytes = res.results.storage.capacity;
      var usedBytes = res.results.storage.size;
      var freeBytes = res.results.storage.free;

      if (totalBytes <= 0) {

      } else {
        var percent = usedBytes / totalBytes;
        jQuery('#rt_storage_bar_inner').css('width', barWidth * percent);
        jQuery("#st_storage_used").text(formSizeByte(usedBytes));
        jQuery("#st_storage_total").text(formSizeByte(totalBytes));
        jQuery("#st_storage_free").text(formSizeByte(freeBytes));
        jQuery("#rt_storage_percent").text(res.results.storage.userate.toFixed(2) + '%');
      }
    }

    updateMainScrollbar();
  }

  // 格式化size（bytes的单位为KB）
  function formSizeByte(bytes, decimalPoint) {
    var num = bytes;
    if (typeof(num) !== "number") {
      num = parseInt(num);
    }
    if (num <= 0) return '0 B';

    var k = 1024,
      dm = decimalPoint || 2,
      sizes = ['B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB', 'BB'],
      i = Math.floor(Math.log(num) / Math.log(k));

    return parseFloat((num / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
  }

  //获取系统日志
  function getSyslog(res) {
    if (res.results.logs) {
      var arr = res.results.logs;
      //填充日志
      jQuery("#resource_log_thumb_container").empty();
      var str = '';
      for (var i = 0, len = arr.length; i < len; ++i) {
        var description = arr[i].description == undefined ? '' : arr[i].description;
        str += '<li class="resource-log-thumb" title="' + description + '">' + description + '</li>';
      }
      jQuery("#resource_log_thumb_container").append(str);
      translateElements('resource_log_thumb_container');
    }
  }

  function translateElements(id) {
    var rt = document.getElementById(id);
    var pageTranslators = window.top.UNAS.CreateNodesTranslators(rt.parentNode);
    var OnChangeLanguage = function(e) {
      for (var i = 0; i < pageTranslators.length; i++) {
        var node = pageTranslators[i].node; // original node
        var p = pageTranslators[i].translateProperty; //the attribues need to be translated
        node[p] = window.top.UNAS._(pageTranslators[i].originalText); //translate
      }
    };
    OnChangeLanguage();
    window.top.UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    window.addEventListener("unload", function(e) {
      window.top.UNAS.Event.removeEvent('ChangeLanguage', OnChangeLanguage);
    }, false);
  }

  function showSyslogLatestError() {
    jQuery.ajax({
      url: "/wmi/index.php",
      type: "POST",
      data: JSON.stringify({
        "cmd": "unas_syslog",
        "token": UToken,
        "params": {
          "type": 4
        }
      }),
      async: true,
      timeout: REQUEST_TIMEOUT,
      contentType: "application/json;charset=utf-8",
      dataType: "json",
      success: function(res) {
        if (res && parseInt(res.err) === 0) {
          if (res.results && res.results.records) {
            if (res.results.records.length > 0) {
              jQuery('#dbz_popup_desc').text(res.results.records[0].EVENTDES);

              translateElements('dbz_popup');

              // jQuery('#dbz_popup').show();
            }

          } else {

          }
        } else {}
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {}
    });
  }
  jQuery('.dbz-popup-btn').on('click', function() {
    jQuery('#dbz_popup').hide();
  });


  function formatTimeFromSeconds(seconds) {
    if (!seconds) return;

    var numSeconds = Number(seconds);

    if (numSeconds > 0) {
      var dayOfSeconds = 24 * 60 * 60;
      var hourOfSeconds = 60 * 60;
      var minuteOfSeconds = 60;

      var day = parseInt(numSeconds / dayOfSeconds);
      var hour = parseInt((numSeconds % dayOfSeconds) / hourOfSeconds);
      var minute = parseInt(((numSeconds % dayOfSeconds) % hourOfSeconds) / minuteOfSeconds);

      return day + UNAS._('##$@resourcepanel@$##D ##$@resourcepanel@$##') +
        hour + UNAS._('##$@resourcepanel@$##H ##$@resourcepanel@$##') +
        minute + UNAS._('##$@resourcepanel@$##M ##$@resourcepanel@$##');
    } else {
      return '';
    }
  }
  function initnetdevicedata(i, data, chart) {
    // 上传速度
    var chartUploadSpeed = echarts.init(chart);
    var optionUploadSpeed = {
      animation: false,
      xAxis: {
        show: false,
        type: 'category',
        boundaryGap: false,
        data: [0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 33, 36, 39, 42, 45, 48, 51, 54, 57, 60],
        axisLabel: {
          fontSize: 10,
        },
        inverse: true,
      },

      tooltip: {
        trigger: 'axis',
        formatter: function(params) {
          var result = '';
          for (var i = 0; i < params.length; i++) {
            result = result + params[i].marker + params[i].seriesName + ': ' + bytesToSize(params[i].value) + '</br>';
          }
          return result;
        }
      },
      yAxis: {
        type: 'value',
        show: false,
      },

      grid: {
        top: 0,
        left: 0,
        right: 0,
        height: '100%',
        width: '100%'
      },
      series: [{
        data: data,
        name: UNAS._('##$@resourcepanel@$##Current Speed##$@resourcepanel@$##'),
        type: 'line',
        smooth: true,
        color: '#FEC367',
        areaStyle: {
          color: {
            type: 'linear',
            x: 0,
            y: 0,
            x2: 0,
            y2: 1,
            colorStops: [{
                offset: 0,
                color: '#FEC367'
              },
              {
                offset: 1,
                color: '#fff'
              }
            ],
            global: false // 缺省为 false
          },
          shadowBlur: 0,
          // opacity: 0.2
        },
        // 设置小圆点消失
        // 注意：设置symbol: 'none'以后，拐点不存在了，设置拐点上显示数值无效
        symbol: 'none',
        // 设置折线弧度，取值：0-1之间
        smooth: 1,
        lineStyle: {
          width: 2
        }
      }]
    };
    chartUploadSpeed.setOption(optionUploadSpeed, true);
    return chartUploadSpeed;
  }
  // 获取cpu, 内存， 网络， 硬盘,网卡速度,日志,存储空间
  function usage_moment() {
    timerInfoMemory.lastStartTime = new Date().getTime();
    // usage_moment
    jQuery.ajax({
      url: "/wmi/index.php",
      type: "POST",
      data: JSON.stringify({
        "cmd": "system_lookout",
        "token": UToken
      }),
      async: true,
      timeout: REFRESH_INTERVAL_ALLOAD,
      contentType: "application/json;charset=utf-8",
      dataType: "json",
      success: function(res) {
        // console.log(res.results);
        if (res.err == 0) {
          let info = res;
          let cpu = info.results.cpu;
          let memory = info.results.memory;
          let diskspeed = info.results.disk;
          let network = info.results.network;

          if (!info.results) {
            return;
          }
          jQuery('#rt_base_username').text(info.results.uid);
          jQuery('#rt_storage_hostname').text(info.results.hostname);
          jQuery('#rt_base_hostname').text(info.results.hostname);
          jQuery('#jv-loadaverage').text(info.results.loadaverage);
          var uptime = "";
          if (info.results.uptime.days > 0) {
            uptime += info.results.uptime.days + UNAS._('##$@taskmanager@$##Days##$@taskmanager@$##');
          }
          if (info.results.uptime.hours > 0 || (info.results.uptime.days > 0 && info.results.uptime.minutes > 0)) {
            uptime += info.results.uptime.hours + UNAS._('##$@taskmanager@$##Hours##$@taskmanager@$##');
          }
          if (info.results.uptime.minutes > 0 || (info.results.uptime.days <= 0 && info.results.uptime.hours <= 0)) {
            uptime += info.results.uptime.minutes + UNAS._('##$@taskmanager@$##Minutes##$@taskmanager@$##');
          }

          jQuery('#rt_base_boottime').html(uptime);

          var strStatus = 'Normal';
          if (info.results.status > 0) {
            jQuery('#jv-statusy').css('background', '#FF4D4F');
            jQuery("#rb_base_status").text(UNAS._('##$@resourcepanel@$##Warning##$@resourcepanel@$##')).css('color', '#FF4D4F');
          } else {
            jQuery('#jv-statusy').css('background', '#2dbf00')
            jQuery("#rb_base_status").text(UNAS._('##$@resourcepanel@$##' + strStatus + '##$@resourcepanel@$##'));
          }

          getCpuInfo(cpu);
          getMemoryInfo(memory);
          if (ecs) {
            getNetdeviceInfo(network);
          }else {
            updateNetdeviceSpeed(network);
          }
          ecs = 0;
          getDiskSpeed(diskspeed);
          getDiskInfo(res);
          getVolumeInfo(res);
          getSyslog(res);
        } else {}

      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {

      },
      complete: function() {
        if (forceStop) return;
        var endTime = new Date().getTime();
        var timeout = endTime - timerInfoMemory.lastStartTime;
        if (timeout > REFRESH_INTERVAL_ALLOAD) {
          usage_moment();
        } else {
          // clearTimeout(timerInfoMemory.lastTimer);
          timerInfoMemory.lastTimer = setTimeout(function() {
            usage_moment();
          }, REFRESH_INTERVAL - timeout);
        }
      }
    });
  }

  function initChart() {
    // cpu使用率
    chartCpuUsage = echarts.init(document.getElementById('cpu_usage_chart'));
    var optionCpuUsage = {
      series: [{
        data: [0],
        type: 'gauge',
        radius: '100%',
        center: ['50%', '50%'],

        startAngle: -270,
        endAngle: 90,
        clockwise: false,

        min: 0,
        max: 100,
        color: {
          type: 'linear',
          colorStops: [{
            offset: 0,
            color: '#2DBF00'
          }]
        },


        //仪表盘轴线相关配置。
        axisLine: {
          lineStyle: {
            width: 10,
            color: [
              [1, '#F6F6F6']
            ]
          }
        },

        progress: {
          show: true,
          overlap: false,
          roundCap: true
        },
        detail: {
          offsetCenter: [10, '0%'],
          valueAnimation: true,
          formatter: function(value) {
            return '{value|' + Math.round(value) + '%}  ';
          },
          rich: {
            value: {
              textAlign: 'center',
              fontSize: 14,
              fontWeight: 600,
              color: '#555'
            }
          }
        },

        axisTick: {
          show: false
        },
        pointer: {
          show: false
        },
        splitLine: {
          show: false,
        },
        axisLabel: {
          show: false
        }
      }]
    };
    chartCpuUsage.setOption(optionCpuUsage, true);


    // 内存使用率
    chartMemory = echarts.init(document.getElementById("memory_usage_chart"));
    var optionMemory = {
      series: [{
        data: [0],

        type: 'gauge',

        radius: '100%',
        center: ['50%', '50%'],

        startAngle: -270,
        endAngle: 90,
        clockwise: false,

        min: 0,
        max: 100,

        color: {
          type: 'linear',
          colorStops: [{
            offset: 0,
            color: '#2DBF00'
          }]
        },

        axisLine: {
          lineStyle: {
            width: 10,
            color: [
              [1, '#F6F6F6']
            ]
          }
        },

        progress: {
          show: true,
          overlap: false,
          roundCap: true
        },

        detail: {
          offsetCenter: [10, '0%'],
          valueAnimation: true,
          formatter: function(value) {
            return '{value|' + Math.round(value) + '%}  ';
          },
          rich: {
            value: {
              textAlign: 'center',
              fontSize: 14,
              fontWeight: 600,
              color: '#333'
            }
          }
        },

        axisTick: {
          show: false
        },
        pointer: {
          show: false
        },
        splitLine: {
          show: false,
        },
        axisLabel: {
          show: false
        }
      }]
    };
    chartMemory.setOption(optionMemory, true);
    // 交换区使用率
    chartSwap = echarts.init(document.getElementById("swap_usage_chart"));
    var optionSwap = {
      series: [{
        data: [0],

        type: 'gauge',

        radius: '100%',
        center: ['50%', '50%'],

        startAngle: -270,
        endAngle: 90,
        clockwise: false,

        min: 0,
        max: 100,

        color: {
          type: 'linear',
          colorStops: [{
            offset: 0,
            color: '#2DBF00'
          }]
        },

        axisLine: {
          lineStyle: {
            width: 10,
            color: [
              [1, '#F6F6F6']
            ]
          }
        },

        progress: {
          show: true,
          overlap: false,
          roundCap: true
        },

        detail: {
          offsetCenter: [10, '0%'],
          valueAnimation: true,
          formatter: function(value) {
            return '{value|' + Math.round(value) + '%}  ';
          },
          rich: {
            value: {
              textAlign: 'center',
              fontSize: 14,
              fontWeight: 600,
              color: '#333'
            }
          }
        },

        axisTick: {
          show: false
        },
        pointer: {
          show: false
        },
        splitLine: {
          show: false,
        },
        axisLabel: {
          show: false
        }
      }]
    };
    chartSwap.setOption(optionSwap, true);


    // // 上传速度
    // chartUploadSpeed = echarts.init(document.getElementById('netdevice_upload_speed_chart'));
    // var optionUploadSpeed = {
    //   animation: false,
    //   xAxis: {
    //     show: false,
    //     type: 'category',
    //     boundaryGap: false,
    //     data: [0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 33, 36, 39, 42, 45, 48, 51, 54, 57, 60],
    //     axisLabel: {
    //       fontSize: 10,
    //     },
    //     inverse: true,
    //   },
    //
    //   tooltip: {
    //     trigger: 'axis',
    //     formatter: function(params) {
    //       var result = '';
    //       for (var i = 0; i < params.length; i++) {
    //         result = result + params[i].marker + params[i].seriesName + ': ' + Math.abs(params[i]
    //           .value).toFixed(2) + 'KB/s' + '</br>';
    //       }
    //       return result;
    //     }
    //   },
    //   yAxis: {
    //     type: 'value',
    //     show: false,
    //   },
    //
    //   grid: {
    //     top: 0,
    //     left: 0,
    //     right: 0,
    //     height: '100%',
    //     width: '100%'
    //   },
    //   series: [{
    //     data: dataUploadSpeed,
    //
    //     name: UNAS._('##$@resourcepanel@$##Current Speed##$@resourcepanel@$##'),
    //     type: 'line',
    //     smooth: true,
    //     color: '#FEC367',
    //     areaStyle: {
    //       color: {
    //         type: 'linear',
    //         x: 0,
    //         y: 0,
    //         x2: 0,
    //         y2: 1,
    //         colorStops: [{
    //             offset: 0,
    //             color: '#FEC367'
    //           },
    //           {
    //             offset: 1,
    //             color: '#fff'
    //           }
    //         ],
    //         global: false // 缺省为 false
    //       },
    //       shadowBlur: 0,
    //       // opacity: 0.2
    //     },
    //     // 设置小圆点消失
    //     // 注意：设置symbol: 'none'以后，拐点不存在了，设置拐点上显示数值无效
    //     symbol: 'none',
    //     // 设置折线弧度，取值：0-1之间
    //     smooth: 1,
    //     lineStyle: {
    //       width: 2
    //     }
    //   }]
    // };
    // chartUploadSpeed.setOption(optionUploadSpeed, true);

    // // 下载速度
    // chartDownloadSpeed = echarts.init(document.getElementById('netdevice_download_speed_chart'));
    // var optionDownloadSpeed = {
    //   animation: false,
    //   xAxis: {
    //     show: false,
    //     type: 'category',
    //     boundaryGap: false,
    //     data: [0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 33, 36, 39, 42, 45, 48, 51, 54, 57, '60s'],
    //     axisLabel: {
    //       fontSize: 10,
    //       // interval: 19
    //     },
    //     inverse: true,
    //   },
    //
    //   tooltip: {
    //     trigger: 'axis',
    //     formatter: function(params) {
    //       var result = '';
    //       for (var i = 0; i < params.length; i++) {
    //         result = result + params[i].marker + params[i].seriesName + ': ' + Math.abs(params[i]
    //           .value).toFixed(2) + 'KB/s' + '</br>';
    //       }
    //       return result;
    //     }
    //   },
    //   yAxis: {
    //     type: 'value',
    //     show: false,
    //   },
    //
    //   grid: {
    //     top: 0,
    //     left: 0,
    //     right: 0,
    //     height: '100%',
    //     width: '100%'
    //   },
    //   series: [{
    //     data: dataDownloadSpeed,
    //
    //     name: UNAS._('##$@resourcepanel@$##Current Speed##$@resourcepanel@$##'),
    //     type: 'line',
    //     smooth: true,
    //     color: '#FEC367',
    //     areaStyle: {
    //       color: {
    //         type: 'linear',
    //         x: 0,
    //         y: 0,
    //         x2: 0,
    //         y2: 1,
    //         colorStops: [{
    //           offset: 0,
    //           color: '#FEC367' // 0% 处的颜色
    //         }, {
    //           offset: 1,
    //           color: '#fff' // 100% 处的颜色
    //         }],
    //         global: false // 缺省为 false
    //       },
    //       shadowBlur: 0,
    //     },
    //     // 设置小圆点消失
    //     // 注意：设置symbol: 'none'以后，拐点不存在了，设置拐点上显示数值无效
    //     symbol: 'none',
    //     // 设置折线弧度，取值：0-1之间
    //     smooth: 1,
    //     lineStyle: {
    //       width: 2
    //     }
    //   }]
    // };
    // chartDownloadSpeed.setOption(optionDownloadSpeed, true);

    // 写入速度
    chartWriteSpeed = echarts.init(document.getElementById('disk_speed_write_chart'));
    var optionWriteSpeed = {
      animation: false,
      xAxis: {
        show: false,
        type: 'category',
        boundaryGap: false,
        data: [0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 33, 36, 39, 42, 45, 48, 51, 54, 57, 60],
        axisLabel: {
          fontSize: 10,
          // interval: 10
        },
        inverse: true,
      },

      tooltip: {
        trigger: 'axis',
        formatter: function(params) {
          var result = '';
          for (var i = 0; i < params.length; i++) {
            result = result + params[i].marker + params[i].seriesName + ': ' + Math.abs(params[i]
              .value).toFixed(2) + 'KB/s' + '</br>';
          }
          return result;
        }
      },
      yAxis: {
        type: 'value',
        show: false,
      },

      grid: {
        top: 0,
        left: 0,
        right: 0,
        height: '100%',
        width: '100%'
      },
      series: [{
        data: [],

        name: UNAS._('##$@resourcepanel@$##Current Speed##$@resourcepanel@$##'),
        type: 'line',
        smooth: true,
        color: '#FFA115',
        areaStyle: {
          // color: "#508AFF",
          color: {
            type: 'linear',
            x: 0,
            y: 0,
            x2: 0,
            y2: 1,
            colorStops: [{
              offset: 0,
              color: '#FFA115' // 0% 处的颜色
            }, {
              offset: 1,
              color: '#FED156' // 100% 处的颜色
            }],
            global: false // 缺省为 false
          },
          shadowBlur: 0,
          // opacity: 0.2
        },
        // 设置小圆点消失
        // 注意：设置symbol: 'none'以后，拐点不存在了，设置拐点上显示数值无效
        symbol: 'none',
        // 设置折线弧度，取值：0-1之间
        smooth: 1,
        lineStyle: {
          width: 2
        }
      }]
    };
    chartWriteSpeed.setOption(optionWriteSpeed, true);

    // 读取速度
    chartReadSpeed = echarts.init(document.getElementById('disk_speed_read_chart'));
    var optionReadSpeed = {
      animation: false,
      xAxis: {
        show: false,
        type: 'category',
        boundaryGap: false,
        data: [0, 3, 6, 9, 12, 15, 18, 21, 24, 27, 30, 33, 36, 39, 42, 45, 48, 51, 54, 57, '60s'],
        axisLabel: {
          fontSize: 10,
          // interval: 10
        },
        inverse: true,
      },

      tooltip: {
        trigger: 'axis',
        formatter: function(params) {
          var result = '';
          for (var i = 0; i < params.length; i++) {
            result = result + params[i].marker + params[i].seriesName + ': ' + Math.abs(params[i]
              .value).toFixed(2) + 'KB/s' + '</br>';
          }
          return result;
        }
      },
      yAxis: {
        type: 'value',
        show: false,
      },

      grid: {
        top: 0,
        left: 0,
        right: 0,
        height: '100%',
        width: '100%'
      },
      series: [{
        data: [],

        name: UNAS._('##$@resourcepanel@$##Current Speed##$@resourcepanel@$##'),
        type: 'line',
        smooth: true,
        color: '#5FE3A1',
        areaStyle: {
          color: {
            type: 'linear',
            x: 0,
            y: 0,
            x2: 0,
            y2: 1,
            colorStops: [{
              offset: 0,
              color: '#5FE3A1' // 0% 处的颜色
            }, {
              offset: 1,
              color: '#5FE3A1' // 100% 处的颜色
            }],
            global: false // 缺省为 false
          },
          shadowBlur: 0,
          // opacity: 0.2
        },
        // 设置小圆点消失
        // 注意：设置symbol: 'none'以后，拐点不存在了，设置拐点上显示数值无效
        symbol: 'none',
        // 设置折线弧度，取值：0-1之间
        smooth: 1,
        lineStyle: {
          width: 2
        }
      }]
    };
    chartReadSpeed.setOption(optionReadSpeed, true);

  }
})();
